/************************************************************************************/
/*  Program name CAPFNDEXT_LOCATION.sql                                             */
/*  Creater:  Karen Nip (PCCW - UniHub)                                             */
/*************   History   *************************                                */
/* 28 DEC, 2005   Karen Nip         First created                                   */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
SET VERIFY OFF

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFNDEXT_LOCATION';

	lv_Scc_Count	NUMBER			:=	0;
	lv_Err_Count	NUMBER			:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPFND_LOCATION.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT
		L.*
	FROM
		--HR_ALL_ORGANIZATION_UNITS	A,
		PER_BUSINESS_GROUPS			A,
		HR_LOCATIONS_ALL			L
	WHERE	UPPER(SUBSTR(A.Name,4,4))	=	p_NGO
	AND		A.Business_Group_ID			=	L.Business_Group_ID;

BEGIN
	lv_NGO_Name		:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.LOCATION_ID||CHR(9)||
				C1.LOCATION_CODE||CHR(9)||
					C1.BUSINESS_GROUP_ID||CHR(9)||
				C1.DESCRIPTION||CHR(9)||
					C1.SHIP_TO_LOCATION_ID||CHR(9)||
				C1.SHIP_TO_SITE_FLAG||CHR(9)||
				C1.RECEIVING_SITE_FLAG||CHR(9)||
				C1.BILL_TO_SITE_FLAG||CHR(9)||
				C1.IN_ORGANIZATION_FLAG||CHR(9)||
				C1.OFFICE_SITE_FLAG||CHR(9)||
				C1.DESIGNATED_RECEIVER_ID||CHR(9)||
					C1.INVENTORY_ORGANIZATION_ID||CHR(9)||
				C1.TAX_NAME||CHR(9)||
				C1.INACTIVE_DATE||CHR(9)||
				C1.STYLE||CHR(9)||
				C1.ADDRESS_LINE_1||CHR(9)||
				C1.ADDRESS_LINE_2||CHR(9)||
				C1.ADDRESS_LINE_3||CHR(9)||
				C1.TOWN_OR_CITY||CHR(9)||
				C1.COUNTRY||CHR(9)||
				C1.POSTAL_CODE||CHR(9)||
				C1.REGION_1||CHR(9)||
				C1.REGION_2||CHR(9)||
				C1.REGION_3||CHR(9)||
				C1.TELEPHONE_NUMBER_1||CHR(9)||
				C1.TELEPHONE_NUMBER_2||CHR(9)||
				C1.TELEPHONE_NUMBER_3||CHR(9)||
				C1.LOC_INFORMATION13||CHR(9)||
				C1.LOC_INFORMATION14||CHR(9)||
				C1.LOC_INFORMATION15||CHR(9)||
				C1.LOC_INFORMATION16||CHR(9)||
				C1.LOC_INFORMATION17||CHR(9)||
				C1.ATTRIBUTE_CATEGORY||CHR(9)||
				C1.ATTRIBUTE1||CHR(9)||
				C1.ATTRIBUTE2||CHR(9)||
				C1.ATTRIBUTE3||CHR(9)||
				C1.ATTRIBUTE4||CHR(9)||
				C1.ATTRIBUTE5||CHR(9)||
				C1.ATTRIBUTE6||CHR(9)||
				C1.ATTRIBUTE7||CHR(9)||
				C1.ATTRIBUTE8||CHR(9)||
				C1.ATTRIBUTE9||CHR(9)||
				C1.ATTRIBUTE10||CHR(9)||
				C1.ATTRIBUTE11||CHR(9)||
				C1.ATTRIBUTE12||CHR(9)||
				C1.ATTRIBUTE13||CHR(9)||
				C1.ATTRIBUTE14||CHR(9)||
				C1.ATTRIBUTE15||CHR(9)||
				C1.ATTRIBUTE16||CHR(9)||
				C1.ATTRIBUTE17||CHR(9)||
				C1.ATTRIBUTE18||CHR(9)||
				C1.ATTRIBUTE19||CHR(9)||
				C1.ATTRIBUTE20||CHR(9)||
				C1.GLOBAL_ATTRIBUTE_CATEGORY||CHR(9)||
				C1.GLOBAL_ATTRIBUTE1||CHR(9)||
				C1.GLOBAL_ATTRIBUTE2||CHR(9)||
				C1.GLOBAL_ATTRIBUTE3||CHR(9)||
				C1.GLOBAL_ATTRIBUTE4||CHR(9)||
				C1.GLOBAL_ATTRIBUTE5||CHR(9)||
				C1.GLOBAL_ATTRIBUTE6||CHR(9)||
				C1.GLOBAL_ATTRIBUTE7||CHR(9)||
				C1.GLOBAL_ATTRIBUTE8||CHR(9)||
				C1.GLOBAL_ATTRIBUTE9||CHR(9)||
				C1.GLOBAL_ATTRIBUTE10||CHR(9)||
				C1.GLOBAL_ATTRIBUTE11||CHR(9)||
				C1.GLOBAL_ATTRIBUTE12||CHR(9)||
				C1.GLOBAL_ATTRIBUTE13||CHR(9)||
				C1.GLOBAL_ATTRIBUTE14||CHR(9)||
				C1.GLOBAL_ATTRIBUTE15||CHR(9)||
				C1.GLOBAL_ATTRIBUTE16||CHR(9)||
				C1.GLOBAL_ATTRIBUTE17||CHR(9)||
				C1.GLOBAL_ATTRIBUTE18||CHR(9)||
				C1.GLOBAL_ATTRIBUTE19||CHR(9)||
				C1.GLOBAL_ATTRIBUTE20||CHR(9)||
				C1.LAST_UPDATE_DATE||CHR(9)||
					C1.LAST_UPDATED_BY||CHR(9)||
				C1.LAST_UPDATE_LOGIN||CHR(9)||
					C1.CREATED_BY||CHR(9)||
				C1.CREATION_DATE||CHR(9)||
					C1.ENTERED_BY||CHR(9)||
				C1.TP_HEADER_ID||CHR(9)||
				C1.ECE_TP_LOCATION_CODE||CHR(9)||
				C1.OBJECT_VERSION_NUMBER||CHR(9)||
				--TO_CHAR(C1.GEOMETRY)||CHR(9)||
				C1.LOC_INFORMATION18||CHR(9)||
				C1.LOC_INFORMATION19||CHR(9)||
				C1.LOC_INFORMATION20||CHR(9)||
				C1.DERIVED_LOCALE||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.LAST_UPDATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.CREATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.ENTERED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetBGName(C1.BUSINESS_GROUP_ID)||CHR(9)||
				CAPBREXT_COMMON.GetOrgName(C1.INVENTORY_ORGANIZATION_ID)
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
		IF	lv_Scc_Count	=	0	THEN
			lv_Err_Msg	:=	lv_NGO_Name||': No location records for this business group';
		END IF;
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/
